(load "bib_lsp")

(setq	*error*	nil)
(setvar	"CMDECHO"	1)

(defun	C:PIECE3D()

  	(setq	DIAM_01		285.0
		DIAM_02		145.0
		DIAM_03P	105.0
		
		RAY_01		(/	DIAM_01		2.0)
		RAY_02		(/	DIAM_02		2.0)
		RAY_03P		(/	DIAM_03P	2.0)

		;;; ---------------------------------------
		;;; petit perage
		
		DIAM_04P	 20.0
		RAY_04P		(/	DIAM_04P	2.0)
		
		NB_PERC		(getint	"\nNombre de perage : ")
		
		EP_01	 	 40.0
		EP_02		 85.0
		 	
		PT1		(list	0.0	0.0	  0.0)
		PT2		(list	0.0	0.0	100.0)
		 
		PT_P1		(polar	PT1	(/	PI	2)	(+	RAY_02	(/	(-	RAY_01	RAY_02)	2)	)	)	
	);setq

  	;;; ----------------------------------------------------------------------------
  	;;; change de SCU ---> SCU FACE

	(SCU_HAUT)

    	;;; ----------------------------------------------------------------------------
  	;;; dessine cercle 1 + EXTRUSION
 
	(command	"_circle"	PT1		RAY_01		)
	(command	"_extrude"	(entlast)	""	EP_01	)
  
	(setq	ENT3D_01	(entlast)	)
  
  	;;; ----------------------------------------------------------------------------
  	;;; dessine cercle 2 + EXTRUSION
 
	(command	"_circle"	PT1		RAY_02		)
	(command	"_extrude"	(entlast)	""	EP_02	)

  	(setq	ENT3D_02	(entlast)	)

  	;;; ----------------------------------------------------------------------------
  	;;; union des 2 EXTRUSIONS

	(command	"_union"	ENT3D_01	ENT3D_02	"")

  	(setq	ENT3D_03	(entlast)	)	;;;	---------------------> = union PIECE 3D
  
  	;;; ----------------------------------------------------------------------------
  	;;; dessine cercle pour le perage + EXTRUSION

	(command	"_circle"	PT_P1		RAY_04P		)
	(command	"_extrude"	(entlast)	""	EP_01	)

  	(setq	ENT3D_04	(entlast)	)
	  
  	;;; ----------------------------------------------------------------------------
  	;;; RESEAU des perages

	(command	"_array"	ENT3D_04	""	"_PO"	PT1	NB_PERC		360.0	"_Yes"	)

    	(setq	ENT3D_05	(entlast)	)

  	;;; ----------------------------------------------------------------------------
  	;;; slectionne une srie d'objet entre objet DEBUT et objet FIN
  	;;; slectionne TOUS les perages dans le jeu de slection   < SELECTENT >
  
  	(ssent	ENT3D_04	ENT3D_05)

  	;;; ----------------------------------------------------------------------------
  	;;; soustraction des PERCAGES
  	;;;
  	(command	"_subtract"	ENT3D_03	""	SELECTENT	""	)

      	(setq	ENT3D_06	(entlast)	)

  	;;; ----------------------------------------------------------------------------
  	;;; dessine cercle pour le perage CENTRAL + SOUSTRACTION
  	;;;
	(command	"_circle"	PT1		RAY_03P				)
	(command	"_extrude"	(entlast)	""	EP_02			)

  	(setq	ENT3D_07	(entlast)	)
  
  	(command	"_subtract"	ENT3D_06	""	ENT3D_07	""	)

  	(setq	ENT3D_08	(entlast)	)

  	(command	"_move"	(entlast)	""	"@"	pause)
  
);defun
