;;;
;;; ce programme permet de faire une slection d'objets
;;; en mode Capture Polygone et Fentre Polygone
;;; en slectionnant une polyligne ferme ou ouverte
;;;
;;; par Christian REB, le 20/01/2006


;;; ----------------------------------------------------
;;; slection objets par une POLYLIGNE en mode CAPTURE
;;; ----------------------------------------------------
 
(defun c:SelCP(/ option_sel)

	(setq	Option_SEL "CP")
	(sel_objet)

(princ)

);defun CP

;;; ----------------------------------------------------
;;; slection objets par une POLYLIGNE en mode FENETRE
;;; ----------------------------------------------------
 
(defun c:SelFP(/ option_sel)

	(setq	Option_SEL "SP")
	(sel_objet)

(princ)

);defun CP

;;; ----------------------------------------------------
;;; fonction de calcul des points et de slection
;;; ----------------------------------------------------

(defun sel_objet(/ ent_selCP lst_pt n_ent num_len lst_pt old_osmode)

	;;; --------------------------
	;;; slection de la polyligne
	;;; --------------------------

	(prompt "\n\rSlectionner une Polyligne pour une Capture Polygone...")

	(while (= ent_selCP nil) 
		
		(setq	ent_selCP (entsel) )

		(setq PT_Liste_SGBD (cadr ent_selCP) )
	
		(prompt "\n\rSlectionner une Polyligne pour une Capture Polygone...")

		(if (= (cdr(assoc 0 (entget (car ent_selCP) ))) "LWPOLYLINE" )
			(setq ent_selCP (entget (car ent_selCP ) ) )
			(setq ent_selCP nil)
		);if

	);while

	(setq	N_ent	(length ent_selCP)
		Num_len	0
		lst_pt	nil
	);setq

	;;; --------------------------------------------
	;;; cration de la liste des points du polygone
	;;; --------------------------------------------

	(while (< num_len N_ent)

		(if (= (car (nth Num_len ent_selCP)) 10)
			(setq lst_pt (cons (cdr (nth Num_len ent_selCP)) lst_pt) )
		);if 
		(setq num_len (+ 1 num_len) )

	);while

	;;; ---------------------------------------
	;;; slection par les Points du polygone
	;;; ---------------------------------------

	(setq old_osmode (getvar "osmode") )
	(setvar "osmode" 0)
	(setvar "cmdecho" 0)
	(command "select" Option_SEL)
	(foreach PT lst_pt (command PT) )

	(setvar "cmdecho" 0)
	(command "" "")
	(setvar "cmdecho" 0)

	(setvar "osmode" old_osmode)

(princ)

);defun

;;; ****************************** FIN PROGRAMME *********************************************
(prompt "\nTaper   SELCP   pour slectionner les objets par une Polyligne en mode CAPTURE")
(prompt "\nTaper   SELFP   pour slectionner les objets par une Polyligne en mode FENETRE")
(princ)