(load "bib_lsp")

;;;(setq	*error*		nil	)
;;;(setvar	"CMDECHO"	1	)

;;; ---------------------------------------------------------------------------------------------------
;;; pice 3D REVOLUTION depuis un profil DIAM EXTERIEUR

(defun	C:REVOL3D_EXT()

  	(setq	DIAM_01		285.0				
		RAY_01		(/	DIAM_01		2.0)	

		;;; ---------------------------------------
		;;; petit perage
		
		DIAM_02P	20.0
		RAY_02P		(/	DIAM_04P	2.0)
		NB_PERC		(getint	"\nNombre de perage : ")
		ECART		17.5		;;; position perage par rapport au bord EXT
		
		EP	 	200.0
		 	
		PT1		(list	0.0	0.0	  0.0)	
		PT_INS		(list	RAY_01	0.0	0.0)		
		PT_P1		(polar	PT1	(/	PI	2)	(-	RAY_01	ECART	)	)	

		PROFIL		"*DIAM_EXT_PROFIL_01"			
		
	);setq

  	;;; ----------------------------------------------------------------------------
  	;;; change de SCU ---> SCU FACE

	(SCU_FACE)
  
  	;;; ----------------------------------------------------------------------------
  	;;; dessine cercle 1 + EXTRUSION

  	(command	"_-insert"	PROFIL	PT_INS	1.0	0.0		)
  	(command	"_revolve"	(entlast)	""	"Y"	360.0	)
  
	(setq	ENT3D_01	(entlast)	)
  
  	;;; ----------------------------------------------------------------------------
  	;;; change de SCU ---> SCU FACE

	(SCU_HAUT)

	;;; ----------------------------------------------------------------------------
  	;;; dessine cercle pour le perage + EXTRUSION

	(command	"_circle"	PT_P1		RAY_02P		)
	(command	"_extrude"	(entlast)	""	EP	)

  	(setq	ENT3D_02	(entlast)	)
	  
  	;;; ----------------------------------------------------------------------------
  	;;; RESEAU des perages

	(command	"_array"	ENT3D_02	""	"_PO"	PT1	NB_PERC		360.0	"_Yes"	)

    	(setq	ENT3D_03	(entlast)	)

  	;;; ----------------------------------------------------------------------------
  	;;; slectionne une srie d'objet entre objet DEBUT et objet FIN
  	;;; slectionne TOUS les perages dans le jeu de slection   < SELECTENT >
  
  	(ssent	ENT3D_02	ENT3D_03)

  	;;; ----------------------------------------------------------------------------
  	;;; soustraction des PERCAGES
  	;;;
  	(command	"_subtract"	ENT3D_01	""	SELECTENT	""	)

      	(setq	ENT3D_04	(entlast)	)

  	;;; ----------------------------------------------------------------------------
  	;;; change de SCU ---> SCU HAUT = SCG

	(SCU_HAUT)
  
    	(command	"_move"	(entlast)	""	"@"	pause)

(princ)
);defun


;;; ---------------------------------------------------------------------------------------------------
;;; pice 3D REVOLUTION depuis un profil DIAM INTERIEUR

(defun	C:REVOL3D_INT()

  	(setq	DIAM_01		285.0				
		RAY_01		(/	DIAM_01		2.0)	

		;;; ---------------------------------------
		;;; petit perage
		
		DIAM_02P	20.0
		RAY_02P		(/	DIAM_04P	2.0)
		NB_PERC		(getint	"\nNombre de perage : ")
		ECART		62.5		;;; position perage par rapport au bord INT
		EP	 	200.0
		 	
		PT1		(list	0.0	0.0	  0.0)	
		PT_INS		(list	RAY_01	0.0	0.0)		
		PT_P1		(polar	PT1	(/	PI	2)	(+	RAY_01	ECART)	)	

		PROFIL		"*DIAM_INT_PROFIL_01"			
		
	);setq

  	;;; ----------------------------------------------------------------------------
  	;;; change de SCU ---> SCU FACE

	(SCU_FACE)
  
  	;;; ----------------------------------------------------------------------------
  	;;; dessine cercle 1 + EXTRUSION

  	(command	"_-insert"	PROFIL	PT_INS	1.0	0.0		)
  	(command	"_revolve"	(entlast)	""	"Y"	360.0	)
  
	(setq	ENT3D_01	(entlast)	)
  
  	;;; ----------------------------------------------------------------------------
  	;;; change de SCU ---> SCU FACE

	(SCU_HAUT)

	;;; ----------------------------------------------------------------------------
  	;;; dessine cercle pour le perage + EXTRUSION

	(command	"_circle"	PT_P1		RAY_02P		)
	(command	"_extrude"	(entlast)	""	EP	)

  	(setq	ENT3D_02	(entlast)	)
	  
  	;;; ----------------------------------------------------------------------------
  	;;; RESEAU des perages

	(command	"_array"	ENT3D_02	""	"_PO"	PT1	NB_PERC		360.0	"_Yes"	)

    	(setq	ENT3D_03	(entlast)	)

  	;;; ----------------------------------------------------------------------------
  	;;; slectionne une srie d'objet entre objet DEBUT et objet FIN
  	;;; slectionne TOUS les perages dans le jeu de slection   < SELECTENT >
  
  	(ssent	ENT3D_02	ENT3D_03)

  	;;; ----------------------------------------------------------------------------
  	;;; soustraction des PERCAGES
  	;;;
  	(command	"_subtract"	ENT3D_01	""	SELECTENT	""	)

      	(setq	ENT3D_04	(entlast)	)

  	;;; ----------------------------------------------------------------------------
  	;;; change de SCU ---> SCU HAUT = SCG

	(SCU_HAUT)

    	(command	"_move"	(entlast)	""	"@"	pause)

(princ)
);defun


;;; --------------------------------------------- FIN PROG -----------------------------------------------------

(prompt "\nTaper   REVOL3D_EXT   pour crer une pice de REVOLUTION  partir d'un PROFIL  <--  EXTERIEUR -->...")
(prompt "\nTaper   REVOL3D_EXT   pour crer une pice de REVOLUTION  partir d'un PROFIL  -->  INTERIEUR <--...")
(princ)