(defun c:gentopo	(/ ss1 blkcount current ed blkspace blkinsert)
  ;; make new layer for topography
  (command "_layer" "_M" "RVTtopo" "_C" "3" "" "")
  ;; select all points
  (setq ss1 (ssget "x" '((0 . "POINT"))))

  (setq blkcount (sslength ss1))
  (setq current 0)

  (while (< current blkcount)
    (setq ed (ssname ss1 current))
    (setq ed (entget ed))
    (setq blkspace (cdr (assoc 410 ed)))
    (setq blkinsert (cdr (assoc 10 ed)))

    (setvar "ctab" blkspace)
;;;
;;; DRAW THE CIRCLE - LAST VALUE IS RADIUS
;;;
    (command "_.circle" blkinsert "0.004")
    (setq current (+ current 1))
  )

  (princ)


)