;;; ----------------------------------
;;; rectangle
;;;
;;; ----------------------------------
;;;
;;;
;;;         P4                     P3
;;;         +++++++++++++++++++++++++
;;;         +                       +
;;;         +                       +
;;;         +                       +
;;;         +                       + LARG
;;;         +                       +
;;;         +                       +
;;;         +           LONG        +
;;;         +++++++++++++++++++++++++
;;;         PT_INS                 P2

(defun	C:rect()

	(setvar		"CMDECHO"	0)	;;; masque l'affichage des commandes
	(setvar		"OSNAPCOORD"	1)	;;; priorit aux coordonnes et NON les accrochages
	(command	"_blipmode"	0)	;;; dsactive les marques 
  	(graphscr)				;;; bascule sur cran GRAPHIQUE
  
	;;; ----------------------------------
	;;; Point d'insertion du rectangle
	(initget	3)			;;; interdire une entre nulle
	(setq	PT_INS	(getpoint "\nCoin bas gauche du rectangle : ") )

	;;; ----------------------------------
	;;; Longueur du rectangle
	(initget	3)			;;; interdire une entre nulle
	(setq	LONG	(getdist  "\n       Longueur du rectangle : ") )

	;;; ----------------------------------
	;;; Largeur du rectangle
	(initget	3)			;;; interdire une entre nulle
	(setq	LARG	(getdist  "\n        Largeur du rectangle : ") )


	;;; ----------------------------------
	;;; appel fonction dessiner rectangle

  	(dessin_rect	PT_INS	LONG	LARG)

	(princ)
  
);defun c:rect()


;;; ---------------------------------------------
;;; dessiner le rectangle
;;;

(defun	dessin_rect ( PT_INS LONG LARG )

	(setq	XP2	( +	(car	PT_INS)	LONG)
		YP2	(cadr 	PT_INS)
		XP3	XP2
		YP3	( +	YP2	LARG)
		XP4	(car	PT_INS)
		YP4	YP3
		P2	(list	XP2	YP2)
		P3	(list	XP3	YP3)
		P4	(list	XP4	YP4)
	);setq

  	;;; ---------------------------------
	;;; sauvegarde ancienne valeur
  
  	(setq	OLD_PLINEWID	(getvar "PLINEWID")
		OLD_OSMODE	(getvar "OSMODE")
	);setq

  	(setvar "PLINEWID"	0.0	)
	(setvar "OSMODE"	0	)

  	(command	"_pline"	PT_INS	P2 P3 P4 "_C")
  
 	(setvar "PLINEWID"	OLD_PLINEWID)
 	(setvar "OSMODE"	OLD_OSMODE)

  
);defun dessin_rect()


;;: ----------------------------------------------
;;; gestion des erreurs
;;;

(defun	*error*(ERR)

  	(princ ERR)

  	(alert	"Du genou tu t'es gour !!!\nComme d'hab !!!!!!!!!")
  
);defun

;;; ------------------------------ fin programme RECTANGLE.LSP -------------------------

(prompt	"\nTaper   RECT   pour dessiner un rectangle par Longueur/Largeur...")

(princ)
