(vl-load-com)

(defun c:RENP(/ doc express lay lst n i txt)

  (setq doc (vla-get-activedocument (vlax-get-acad-object))

        n 1

        i 1

  )

  (vla-startundomark doc)

  (if (eval 'acet-ui-progress-done)

    (progn

      (acet-ui-progress-init "" (1- (vla-get-count (vla-get-layouts doc))))

      (setq express T)

    )

    (progn

      (princ "\nTravail en cours...")

      (princ)

    )

  )

  (vlax-for lay (vla-get-layouts doc)

    (setq lst (cons (list (vla-get-taborder lay) lay) lst))

  )

  (while (setq lay (assoc i lst))

    (if (eq n -1)

      (setq txt "Cart")

      (setq txt (itoa n))

    )

    (while (< (strlen txt) 2)

      (setq txt (strcat "0" txt))

    )

    (if (vl-catch-all-error-p (vl-catch-all-apply 'vla-put-name (list (cadr lay) txt)))

      (progn

        (vla-put-name (vla-item (vla-get-layouts doc) txt) (strcat "Temporaire_Patrick_35___" txt))

        (vla-put-name (cadr lay) txt)

      )

    )

    (and express (acet-ui-progress-safe i))

    (setq n (1+ n)

          i (1+ i)

    )

  )

  (and express (acet-ui-progress-done))

  (princ (strcat "\nRenumrotation de " (itoa (1+ n)) " prsentation(s)."))

  (vla-endundomark doc)

  (princ)

)

;;; -----------------------------------------------------

(prompt "\nTaper    RENP   pour renommer les prsentations...")

(princ)

